function [score_matrix,numhid]=RBM_model(interaction_matrix)      %޲ķ
numhid=internal_RBM(interaction_matrix);                        %numhidnumber of hidden layers
learning_rate=0.1;
[drug_num,sideeffect_num]=size(interaction_matrix);
[model, errors] = rbmBB(interaction_matrix,numhid,'verbose',true,'eta',learning_rate);
ph = logistic(interaction_matrix*model.W + repmat(model.b,drug_num,1));
phstates = ph > rand(drug_num,numhid);
predicted_interaction_matrix = logistic(phstates*model.W' + repmat(model.c,drug_num,1));
score_matrix=predicted_interaction_matrix;
end

function best=internal_RBM(interaction_matrix)                 
fprintf('start RBM internal cross validationѰ\n')
aupr=zeros(11,1);
for threshold=1:11
  CV=5;
  rand('state',6);
  [row,col]=size(interaction_matrix);
  cv_matrix=ceil(rand(row,col)*CV);
  predict_score_matrix=zeros(row,col);
  hidden_num=10*(threshold+1);
  for k=1:CV                                                               %Ľ֤ǶԲthreshold֤
%         fprintf('begin to implement the cross validation:round =%d/%d ѵѲ\n', k, CV);

        test_index_matrix=logical(cv_matrix==k);
        train_index_matrix=~ test_index_matrix;
        train_interaction_matrix=interaction_matrix.*train_index_matrix;
        predict_matrix=RBM(train_interaction_matrix,hidden_num);
        predict_score_matrix=predict_score_matrix+ predict_matrix.*(test_index_matrix);

% %ǵgpuٵĴ
%           test_index_matrix=logical(cv_matrix==k);
%           
%           test_index_matrix=gpuArray(test_index_matrix); %GPU,ݴgpu
%           interaction_matrix=gpuArray(interaction_matrix);%gpu
%           
%           train_index_matrix=~ test_index_matrix;
%           train_interaction_matrix=interaction_matrix.*train_index_matrix;
%           train_interaction_matrix=gather(train_interaction_matrix); %ʹgatherݴgpucpu
%          
%           predict_matrix=RBM(train_interaction_matrix,hidden_num);
%           
%           predict_matrix=gpuArray(predict_matrix);
%           test_index_matrix=gpuArray(test_index_matrix);
%           predict_score_matrix=gpuArray(predict_score_matrix); 
%           
%           predict_score_matrix=predict_score_matrix+ predict_matrix.*(test_index_matrix);
%           
%           predict_score_matrix=gather(predict_score_matrix);
%           interaction_matrix=gather(interaction_matrix);%ʹgatherݴgpucpu
% %           train_interaction_matrix=gather(train_interaction_matrix);
% %           predict_matrix=gather(predict_matrix);
%            test_index_matrix=gather(test_index_matrix);
       
  end
  aupr(threshold,1)=AUPR(interaction_matrix(:),predict_score_matrix(:));
end
[max_score,index]=max(aupr)
best=10*(index+1);
end

function score_matrix=RBM(interaction_matrix,numhid)    
learning_rate=0.1;
[drug_num,sideeffect_num]=size(interaction_matrix);
[model, errors] = rbmBB(interaction_matrix,numhid,'verbose',true,'eta',learning_rate);   %Ӧ޲ҳļ㲿
ph = logistic(interaction_matrix*model.W + repmat(model.b,drug_num,1));
phstates = ph > rand(drug_num,numhid);
predicted_interaction_matrix = logistic(phstates*model.W' + repmat(model.c,drug_num,1));
score_matrix=predicted_interaction_matrix;
end


function area=AUPR(real,predict)                                    %AUPR
%addpath('D:\matlab2016\side effects\source code and datasets\RBMLIB\RBM');
max_value=max(predict);
min_value=min(predict);

threshold=min_value+(max_value-min_value)*(1:99)/100;

threshold=threshold';
threshold_num=length(threshold);
tn=zeros(threshold_num,1);
tp=zeros(threshold_num,1);
fn=zeros(threshold_num,1);
fp=zeros(threshold_num,1);

for i=1:threshold_num
    tp_index=logical(predict>=threshold(i) & real==1);
    tp(i,1)=sum(tp_index);
    
    tn_index=logical(predict<threshold(i) & real==0);
    tn(i,1)=sum(tn_index);
    
    fp_index=logical(predict>=threshold(i) & real==0);
    fp(i,1)=sum(fp_index);
    
    fn_index=logical(predict<threshold(i) & real==1);
    fn(i,1)=sum(fn_index);
end

sen=tp./(tp+fn);
% spe=tn./(tn+fp);
precision=tp./(tp+fp);
recall=sen;
x=recall;
y=precision;
[x,index]=sort(x);
y=y(index,:);

area=0;
x(1,1)=0;
y(1,1)=1;
x(threshold_num+1,1)=1;
y(threshold_num+1,1)=0;
area=0.5*x(1)*(1+y(1));
for i=1:threshold_num
    area=area+(y(i)+y(i+1))*(x(i+1)-x(i))/2;
end

end